# __Anu__

This package is part of the ___Anu___-family. 

___Anu___ (_అణు_) is a word in Telugu (a language spoken in south india) which means as much as atomic.   Thats what every __Anu__-package should be about. Simple and clean.

All ___Anu___-packages are available via npm and can be used with javascript __and__ typescript. The packages are written in typescript and compiled to javascript + a type definition file.


## __Anu__-Localization

This module provides basic localization for strings.

## __How__ To Use

### Structure
![The structure anu-localization](doc/anulocalizationstructure.png "Anu-Localization Structure")


### Setting up the configuration:

The configuration should look like this:
```json
{
    "FallbackLanguage": "english",
    "RegexString": "T{(\\w+)}",
    "LocalizationLanguages": [
        {
            "Key": "german",
            "FilePath": "./localization.json",
            "HttpLanguageKey": "de"
        },
        {
            "Key": "english",
            "FilePath": "./localization.json",
            "HttpLanguageKey": "en"
        }
    ]
}
```
+ "FallbackLanguage": The language which is used if the configuration does not include one of the languages the Http-request wants.
+ "RegexString": The regular expression which will be used to identify the keys in a html document that should be translated.
+ "LocalizationLanguages": An array of languages this application supports.
+ "Key": The key that is used to find the appropriate translation for the language. 
+ "FilePath": The path to the file that contains the translations for the language.
+ "HttpLanguageKey": The key which is used in Http-request.


### Setting up a file containing translations:

A file that contains translation should look like this:
```json
[
    {
        "Key": "TEST",
        "Translations": [
            {
                "LanguageKey": "english",
                "Translation": "testenglish"
            },
            {
                "LanguageKey": "german",
                "Translation": "testdeutsch"
            }
        ]
    }
]
```
+ "Key": The key that should be translated.
+ "Translations": The appropriate translations.
+ "LanguageKey": The key of the appropriate language.
+ "Translation": The translation.

### The service:

```typescript
/**
* Translates a string.
* @param stringForTranslation The string which should be translated.
* @param languages The languages for which the translation should be found.
* @param localizationObjects The objects that should contain the translations.
*/
public TranslateWholeString(
    stringForTranslation: string,
    languages: LocalizationLanguage[], 
    localizationObjects: LocalizationObject[]): string;
```

```typescript
/**
* Translates a key.
* @param key The key which should be translated.
* @param languages The languages for which the translation should be found.
* @param localizationObjects The objects that should contain the translation.
*/
public Translate(
    key: string, 
    languages: LocalizationLanguage[], 
    localizationObjects: LocalizationObject[]): string;
```